<template>
  <div>
    <input type="number" v-model="id" />
    <div v-if="$apollo.queries.todo.loading">Loading 1 todo...</div>
    <div v-else>
      {{ todo }}
    </div>

    <hr />
    <hr />
    <hr />

    <div v-if="$apollo.queries.todos.loading">Loading...</div>
    <div v-else>
      <ul>
        <li
          v-for="todoItem in todos"
          :key="`${todoItem.id}-${todoItem.user.name}`"
        >
          {{ todoItem.id }} {{ todoItem.title }}
          <ul>
            <li v-if="todoItem.user.__typename === 'ClientUser'">
              {{ todoItem.user.name }}
            </li>
          </ul>
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import todoListQuery from "../graphql/todoList.query.gql";
import todoQuery from "../graphql/todo.query.gql";

export default {
  name: "HelloWorld",
  props: {
    msg: String,
  },
  apollo: {
    todos: {
      query: todoListQuery,
      fetchPolicy: "cache-first",
    },
    todo: {
      query: todoQuery,
      variables() {
        return { id: this.id };
      },
    },
  },
  data() {
    return { id: 1 };
  },
};
</script>
